

addplaceablecategorie = {};
local modDirectory = g_currentModDirectory or ""
local modName = g_currentModName or "unknown"

function addplaceablecategorie:addowncategory()
    self.modDirectory = modDirectory
    self.modName = modName
    local constructionXMLFile = XMLFile.load("constructionXML", Utils.getFilename("xml/constructionCategories.xml", self.modDirectory))

	if constructionXMLFile ~= nil then
		local defaultIconFilename = self.modDirectory .. constructionXMLFile:getString("constructionCategories#defaultIconFilename")
		local defaultRefSize = constructionXMLFile:getVector("constructionCategories#refSize", {
			1024,
			1024
		}, 2)

		constructionXMLFile:iterate("constructionCategories.category", function (_, key)
			local categoryName = constructionXMLFile:getString(key .. "#name")
--            categoryName = categoryName:upper()
--            if g_storeManager.constructionCategoriesByName[categoryName] ~= nil then
--                return
--            end
			local title = g_i18n:convertText(constructionXMLFile:getString(key .. "#title"))
			local iconFilename = constructionXMLFile:getString(key .. "#iconFilename") or defaultIconFilename
			local refSize = constructionXMLFile:getVector(key .. "#refSize", defaultRefSize, 2)
			local iconUVs = GuiUtils.getUVs(constructionXMLFile:getString(key .. "#iconUVs", "0 0 1 1"), refSize)

			g_storeManager:addConstructionCategory(categoryName, title, iconFilename, iconUVs, "")
			constructionXMLFile:iterate(key .. ".tab", function (_, tKey)
				local tabName = constructionXMLFile:getString(tKey .. "#name")
				local tabTitle = g_i18n:convertText(constructionXMLFile:getString(tKey .. "#title"))
				local tabIconFilename = constructionXMLFile:getString(tKey .. "#iconFilename") or defaultIconFilename
				local tabRefSize = constructionXMLFile:getVector(tKey .. "#refSize", defaultRefSize, 2)
				local tabIconUVs = GuiUtils.getUVs(constructionXMLFile:getString(tKey .. "#iconUVs", "0 0 1 1"), tabRefSize)

				g_storeManager:addConstructionTab(categoryName, tabName, tabTitle, tabIconFilename, tabIconUVs, "")
			end)
		end)
		constructionXMLFile:delete()
	end
end

function loadMapData(xmlFile, missionInfo, baseDirectory)
    addplaceablecategorie:addowncategory()
end

StoreManager.loadMapData = Utils.appendedFunction(StoreManager.loadMapData, loadMapData)